local libInfo = 'HDD_ATA_Samsung 0.3 - 30.04.2017'

includeParentLib('HDD_ATA.lua')

--SILENCE-------------------------------------------------------------------------------------------------------------------
device.diag[regFunction('NOTDETECTED_SILENCE', libInfo)] = function ()  
    if  device.NOTDETECTED 
    and device.FORM_SOUND == 'SILENCE' 
    and device.FORM_SPINS_UP ~= 'YES' 
    then   
        if  device.FORM_ROM_NOT_ORIGINAL == 'YES'
        and device.FORM_MECHANICAL_SHOCK ~= 'YES'
        and device.FORM_PCB_DAMAGE ~= 'YES'
        and device.FORM_ELECTRICAL_DAMAGE ~= 'YES'
        then
            device.fail.fw:highProbability()
            addExplanation('No sound out of a drive with non-original ROM usually means incompatible firmware.')
        end
      
        if  device.FORM_ELECTRICAL_DAMAGE ~= 'YES'
        and device.FORM_PCB_DAMAGE ~= 'YES'
        and device.FORM_ROM_NOT_ORIGINAL ~= 'YES'
        and device.FORM_SMELLS_BURNT ~= 'YES'
        then
            device.fail.pcb:highProbability()
            device.fail.fw:highProbability()
            addExplanation('No sound out of a Samsung hard drive in its reference operating condition is usually a sign of PCB issues and firmware damage.')
        end
 
        if  ( device.FORM_ELECTRICAL_DAMAGE == 'YES' or  device.FORM_SMELLS_BURNT == 'YES' or device.FORM_PCB_DAMAGE ~= 'YES' )
        and device.FORM_MECHANICAL_SHOCK ~= 'YES'
        and device.FORM_ROM_NOT_ORIGINAL ~= 'YES'
        then
            device.fail.pcb:highProbability()
            device.fail.heads:probability()
            addExplanation('No sound out of a drive with suspected PCB failure is frequently a confirmation of PCB issues and may also be a sign of bad heads.')
        end
    end    
end