local libInfo = 'HDD_ATA_WDC 0.2 - 21.08.2016'

includeParentLib('HDD_ATA.lua')

--SILENCE-------------------------------------------------------------------------------------------------------------------
device.diag[regFunction('NOTDETECTED_SILENCE', libInfo)] = function ()  
    if  device.NOTDETECTED 
    and device.FORM_SOUND == 'SILENCE' 
    and device.FORM_SPINS_UP ~= 'YES' 
    then   
        if  device.FORM_ROM_NOT_ORIGINAL == 'YES'
        and device.FORM_MECHANICAL_SHOCK ~= 'YES'
        and device.FORM_PCB_DAMAGE ~= 'YES'
        and device.FORM_ELECTRICAL_DAMAGE ~= 'YES'
        then
            device.fail.fw:highProbability()
            addExplanation('No sound out of a drive with non-original ROM usually means incompatible firmware.')
        end
      
        if  device.FORM_ELECTRICAL_DAMAGE ~= 'YES'
        and device.FORM_PCB_DAMAGE ~= 'YES'
        and device.FORM_ROM_NOT_ORIGINAL ~= 'YES'
        and device.FORM_SMELLS_BURNT ~= 'YES'
        then
            device.fail.pcb:probability()
            device.fail.heads:probability()
            addExplanation('No sound out of a ((WD hard)) drive in its reference operating condition could be a sign of PCB issues or bad heads.')
        end
 
        if  ( device.FORM_ELECTRICAL_DAMAGE == 'YES' or  device.FORM_SMELLS_BURNT == 'YES' or device.FORM_PCB_DAMAGE == 'YES' )
        and device.FORM_MECHANICAL_SHOCK ~= 'YES'
        and device.FORM_ROM_NOT_ORIGINAL ~= 'YES'
        then
            device.fail.pcb:highProbability()
            device.fail.heads:highProbability()
            addExplanation('No sound out of a WD hard drive with suspected PCB failure is frequently a confirmation of PCB issues with the possibility of bad heads.')
        end
    end
end