local libInfo = 'SSD_SCSI 0.1 - 28.04.2018'

includeParentLib('SSD.lua')


-- Rules for the S.M.A.R.T analisys. =================================================================================================

-- Malfunctions-----------------------------------------------------------------------------------------------------------------------------------------
device.diag[regFunction('SP_DIAGNOSTICS', libInfo)] = function ()

-- #log[2..5].param0006
    if (device.log02 and device.log02.param0006 and ( device.log02.param0006 > 0 )) or
       (device.log03 and device.log03.param0006 and ( device.log03.param0006 > 0 )) or
       (device.log04 and device.log04.param0006 and ( device.log04.param0006 > 0 )) or
       (device.log05 and device.log05.param0006 and ( device.log05.param0006 > 0 ))
    then 
	    device.fail.bb:highProbability()
	    addExplanation('According to the R/W error counter analysis, the drive is likely to have bad sectors.')

    	if device.log02 and device.log02.param0006 and ( device.log02.param0006 > 0 )
    	then 
    		device.fail.writefault:highProbability()
    		addExplanation('Write error counter shows write errors, which is abnormal.')
    	end
    end

-- #log11.param0001 SSD Wearout indicator
    if device.log11 and device.log11.param0001 and ( device.log11.param0001 > 79 )
    then 
        device.fail.bb:probability()
        addExplanation('Media wearout indicator is above the reasonable limit of 80%.')
    end

-- #log80.param0000 GLIST entries (emulated for easy use!)
    if device.log80 and device.log80.param0000 and ( device.log80.param0000 > 0 )
    then 
        device.fail.bb:highProbability()
        addExplanation('Grown Defect List (GList) is not empty - reallocated sectors are present, some data might have been lost.')
    end
end

--Warnings-----------------------------------------------------------------------------------------------------------------------------------------
device.diag[regFunction('SMART_WARNINGS', libInfo)] = function ()

-- #log2F.param0000 Predictive Failure Analysis state (PFA)
    if device.log2F and device.log2F.param0000 and ( device.log2F.param0000 > 0 )
    then 
        addExplanation('Device reports a Predictive Failure Analysis (PFA) error!')
    end

-- #log[2..5].param0006
    if device.log0D and device.log0D.param0000 and ( device.log0D.param0000 > 59 )
    then
        addWarning('Drive temperature is too high.')
    end
-- #193 
    if device.log0E and device.log0E.param0004 and ( device.log0E.param0004 > 9900 )
    then 
        addWarning('Too many start/stop counts.')
    end

-- #log11.param0001 SSD Wearout indicator
    if device.log11 and device.log11.param0001 and ( device.log11.param0001 > 0 )
    then 
	if device.log11.param0001 < 10
	then 
		addWarning('Media wearout indicator is still below 10%.')
	end
	if (device.log11.param0001 > 9) and (device.log11.param0001 < 50)
	then 
		addWarning('The drive is worn out to some extent, but corresponding indicator is below 50%.')
	else
		addWarning('Drive wearout is rather high (above 50%).')
	end
    end
end
